function HTMLReader(aCharSet) {
  if(aCharSet)this.charSet=aCharSet;
}

/***********************************************************
load html
***********************************************************/
HTMLReader.prototype.getHtml = function(aCallback,aURL,aPostData) {
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  // create an nsIURI
  var uri = ioService.newURI(aURL, null, null);
  //nsIInputStream
  var uploadStream = Components.classes["@mozilla.org/io/string-input-stream;1"]
    .createInstance(Components.interfaces.nsIStringInputStream);
  if (aPostData)
    uploadStream.setData(aPostData, aPostData.length);

  // get a channel for that nsIURI
  var channel = ioService.newChannelFromURI(uri);

  // get a httpchannel and make it a post
  var httpChannel = channel.QueryInterface(Components.interfaces.nsIHttpChannel);
  if (aPostData) {
    var uploadChannel = channel.QueryInterface(Components.interfaces.nsIUploadChannel);
    uploadChannel.setUploadStream(uploadStream, "application/x-www-form-urlencoded", -1);
    httpChannel.requestMethod = "POST";
  }
  this.callback=aCallback;
  channel.asyncOpen(this,httpChannel);
}
HTMLReader.prototype.onStartRequest = function (aRequest, aContext) {
  this.data = "";
}
HTMLReader.prototype.onDataAvailable = function (aRequest, aContext, aStream, aSourceOffset, aLength){
  var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
                   .createInstance(Components.interfaces.nsIConverterInputStream);
  var httpChannel=aContext.QueryInterface(Components.interfaces.nsIHttpChannel);
  is.init(aStream,
          this.charSet?this.charSet:(httpChannel.contentCharset?httpChannel.contentCharset:"utf-8"),
          1024,
          Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);
  var str = {};
  while (is.readString(4096, str) != 0) {
    this.data+=str.value;
  }
}

HTMLReader.prototype.onStopRequest = function (aRequest, aContext, aStatus) {
  var response=-1;
  try{
    response=aContext.QueryInterface(Components.interfaces.nsIHttpChannel).responseStatus
  }catch(e){}
  this.callback.callback(this.data,response,aContext);
}
