/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is SKT-SMS.
 *
 * The Initial Developer of the Original Code is
 * Byung-Wook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const passwordURI="chrome://skt-sms/tworld"

const ERR_GET_DATA=0;

const DATA_VASP_ID=0;
const DATA_VAS_ID=1;
const DATA_SMS_IP=2;
const DATA_SMS_PORT=3;
const DATA_SMS_FREERCVFILE=4;
const DATA_USER_KEY=5;
const DATA_USER_MDN=6;
const DATA_USER_NUM=7;
const DATA_USER_LEVEL=8;
const DATA_FREE_COUNT=9;

const STAGE_READY=10;
const STAGE_SEND=11;

var main={
  branch:null,
  stage:0,
  reader:new HTMLReader("euc-kr"),

  userData:[],

  onLoad:function(){
    document.getElementById("msg").inputField.spellcheck=false;
    document.getElementById("msg").inputField.style.overflowX="hidden";
    document.getElementById("msg").inputField.style.overflowY="scroll";

    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    this.branch = prefService.getBranch("skt-sms.");
    this.branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
    var username=this.branch.getCharPref("username");
    document.getElementById("username").value=username;
    var sender=this.branch.getCharPref("sender");
    if(!document.getElementById("sender").value)
      document.getElementById("sender").value=sender;

    var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
                                .getService(Components.interfaces.nsIPasswordManager);
    var e = passwordManager.enumerator;
    var password;
    while (e.hasMoreElements()) {
      try {
        var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
        if (pass.host == passwordURI&&pass.user==username) {
           password=pass.password; // the password
           break;
        }
      }catch(ex) {
      }
    }
    if(password)document.getElementById("password").value=password;
    else this.toggle();
    document.getElementById("msg").focus();
  },
  toggle : function(){
    document.getElementById("loginbox").collapsed=!document.getElementById("loginbox").collapsed;
    document.getElementById("togglebutton").src
      =document.getElementById("loginbox").collapsed?"arrow-right.png":"arrow-left.png";
    window.sizeToContent();
  },
  checkValue : function(name,desc){
    var val=document.getElementById(name).value
    if(!val){
      alert(desc+this.getString("Required"));
      return null;
    }else return val;
  },
  onSend :function(){
    this.setStatus("");
    var username;
    if(username=this.checkValue("username",this.getString("Username"))){
      this.branch.setCharPref("username",username);
    }else return;
    var password;
    if(password=this.checkValue("password",this.getString("Password"))){
      var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
                                    .getService(Components.interfaces.nsIPasswordManager);
      try{
        passwordManager.removeUser(passwordURI,username);
      }catch(e){}
      passwordManager.addUser(passwordURI,username,password);
    }else return;
    var sender;
    if(sender=this.checkValue("sender",this.getString("SenderNumber"))){
      this.branch.setCharPref("sender",sender);
    }else return;
    if(!this.userData[DATA_USER_KEY]){
      this.stage=0;
      document.getElementById("progress").value=0;
      document.getElementById("progpanel").collapsed=false;
      this.reader.getHtml(this,"http://www.tworld.co.kr:8009/center/sms/send/cm6_sms_member.jsp");
    }else this.send();
  },
  showError:function (code){
    switch(code){
      case ERR_GET_DATA:
        this.setStatus(this.getString("Error")+"["+this.stage+"]");
      break;
    }
  },
  setStatus:function (str){
    document.getElementById("progpanel").collapsed=true;
    document.getElementById("status").value=str;
  }
}
main.callback=function (aData, aStatus,aHttp){
  document.getElementById("progress").value=100*this.stage/7;
  var fnd;
  switch(this.stage){
  case 0:
    if(aStatus==302){//not logged in
        this.reader.getHtml(this,"http://www.tworld.co.kr:8001/common/loginout/view/cm6_login_page.jsp?returnURL=http://www.tworld.co.kr:8009/center/sms/send/cm6_sms_member.jsp");
    }else if(aStatus==200){
      this.stage=3;
      this.callback(aData,aStatus,aHttp);
      return;
    }else this.showError(0);
    break;
  case 1://get server ip
    fnd=aData.match(/SERVERIP\s+value=(\S+)>/);
    if(fnd){
      var serverIP=fnd[1];
      //out(serverIP);
      this.reader.getHtml(this,"http://icasams.sktelecom.com:2040/icas/fc/LogOnSV",
          "URL=http%3A%2F%2Fwww.tworld.co.kr%3A8001%2Fcommon%2Floginout%2Fcontrol%2FLoginServlet.jsp%3FreturnURL%3Dhttp%253A%252F%252Fwww.tworld.co.kr%253A8009%252Fcenter%252Fsms%252Fsend%252Fcm6_sms_member.jsp%26kind%3D%26cmd%3D"
          +"&SERVERIP="+serverIP
          +"&ID="+document.getElementById("username").value
          +"&PASSWORD="+document.getElementById("password").value
      );
    }else this.showError(0);
    break;
  case 2:
    if(aStatus==302){//logged in
      this.reader.getHtml(this,"http://www.tworld.co.kr:8009/center/sms/send/cm6_sms_member.jsp");
    }else this.showError(0);
    break;
  case 3://find url
    fnd=aData.match(/IFRAME\s+src="(\S+)"/);
    if(fnd){
      this.reader.getHtml(this,fnd[1]);
    }else this.showError(0);
    break;
  case 4:
    fnd=aData.match(/"mainpage"[\s\S]+?src="(\S+)"/);
    if(fnd){
      this.reader.getHtml(this,fnd[1]);
    }else this.showError(0);
    break;
  case 5:
    fnd=aData.match(/href="(\S+)"/);
    if(fnd){
      this.reader.getHtml(this,"http://mpr.nate.com"+fnd[1]);
    }else this.showError(0);
    break;
  case 6:
    fnd=aData.match(/"leftFrame"[\s\S]+?src="(\S+)"/);
    if(fnd){
      this.reader.getHtml(this,"http://mpr.nate.com"+fnd[1]);
    }else this.showError(0);
    break;
  case 7:
    var reg=[/RXA_VASP_ID\s*?=\s*?"(\S+?)"/,
              /RXA_VAS_ID\s*?=\s*?"(\S+?)"/,
              /RXA_SMS_IP\s*?=\s*?"(\S+?)"/,
              /RXA_SMS_PORT\s*?=\s*?"(\S+?)"/,
              /RXA_SMS_FREERCVFILE\s*?=\s*?"(\S+?)"/,
              /RXA_USER_KEY\s*?=\s*?"(\S+?)"/,
              /RXA_USER_MDN\s*?=\s*?"(\S+?)"/,
              /RXA_USER_NUM\s*?=\s*?"(\S+?)"/,
              /RXA_USER_LEVEL\s*?=\s*?"(\S+?)"/,
              /RXA_FREE_COUNT\s*?=\s*?"(\S+?)"/
        ];
    for(var i=0;i<reg.length;i++){
      fnd=aData.match(reg[i]);
      if(fnd){
        this.userData[i]=fnd[1];
      }else{
        this.showError(0);
        return;
      }
    }
    if(!document.getElementById("sender").value)document.getElementById("sender").value=this.userData[DATA_USER_MDN];
    document.getElementById("freecount").value=this.userData[DATA_FREE_COUNT];
    this.stage=STAGE_READY;
    document.getElementById("progpanel").collapsed=true;
    this.send();
    break;
  case STAGE_SEND:
    fnd=aData.match(/<RESULT>(\d+)<\/RESULT>/);
    if(aStatus==200&&fnd&&fnd[1]==0){
      this.setStatus(this.getString("Sent"));
      if(document.getElementById("freecount").value>0){
        document.getElementById("freecount").value--;
      }
    }else{
      this.setStatus(this.getString("Failed"));
    }
    break;
  }
  if(this.stage<STAGE_READY)this.stage++;
}
main.send=function(){
  this.stage=STAGE_SEND;
    var sender=document.getElementById("sender").value;
    if(!sender){
      alert(this.getString("NoSenderNumber"));
      return;}
    var receiver=document.getElementById("receiver").value;
    if(!receiver){
      alert(this.getString("NoReceiverNumber"));
      return;}
    var txt=getText();
    if(!txt){
      alert(this.getString("NoMessage"));
      return;}
    var formhistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService (Components.interfaces.nsIFormHistory ? Components.interfaces.nsIFormHistory : Components.interfaces.nsIFormHistory2);
    formhistory.addEntry("skt-sms-receiver", receiver);
    var post="TYPE=01&VASP_ID="+this.userData[DATA_VASP_ID]
            +"&VAS_ID="+this.userData[DATA_VAS_ID]
            +"&VAS_CASH_YN=N&USER_LEVEL="+this.userData[DATA_USER_LEVEL]
            +"&USER_ID="+this.userData[DATA_USER_KEY]
            +"&USER_NUM="+this.userData[DATA_USER_NUM]
            +"&CASH_KEY=&FREE_COUNT="+this.userData[DATA_FREE_COUNT]
            +"&SEND_MDN="+sender+"&DELIVERY_TIME=&RECV_MDN="+receiver
            +"&CALL_MDN="+sender+"&TEXT="+URLencode(txt);
    var url="http://"+this.userData[DATA_SMS_IP]
              +":"+this.userData[DATA_SMS_PORT]
              +this.userData[DATA_SMS_FREERCVFILE];
  this.setStatus(this.getString("Sending")+"...");
  this.reader.getHtml(this,url,post);
}

function txtinput(textbox){
  var str=textbox.value;
  var cols=textbox.getAttribute("cols");
  var maxlength=textbox.getAttribute("maxlength");
  var count=0;
  var str2="";
  var pos=0;
  var newlines=0;
  var start=textbox.selectionStart;
  for(var i=0;i<str.length;i++){
    var c=str.charAt(i);
    var code=str.charCodeAt(i);
    if(c=='\n'){
      if(pos<cols){
        if(count>=maxlength)break;
        count++;
      }
      pos=0;
    }else{
      if(str.charCodeAt(i)<255){
        if(count>=maxlength)break;
        count++;
        pos++;
        if(pos>cols){
          pos=0;
          str2+='\n'
          if(i<start)newlines++;
        }
      }else{
        if(count>=maxlength-1)break;
        count+=2;
        pos+=2;
        if(pos>cols)pos=2;
      }
    }
    str2+=c;
  }
  document.getElementById("count").value=count+"/80";
  var end=textbox.selectionEnd;
  textbox.value=str2;
  textbox.selectionStart=start+newlines;
  textbox.selectionEnd=end+newlines;
}
function getText(){
  var str=document.getElementById("msg").value;
  var cols=document.getElementById("msg").getAttribute("cols");
  var str2="";
  var pos=0;
  for(var i=0;i<str.length;i++){
    var c=str.charAt(i);
    var code=str.charCodeAt(i);
    if(c=='\n'){
      if(pos<cols)str2+=c;
      pos=0;
    }else{
      if(str.charCodeAt(i)<255){
        pos++;
        if(pos>cols){
          pos=0;
        }
      }else{
        pos+=2;
        if(pos>cols)pos=2;
      }
      str2+=c;
    }
  }
  return str2;
}
function URLencode(str) {
  return Components.classes["@mozilla.org/intl/texttosuburi;1"]
            .getService(Components.interfaces.nsITextToSubURI)
              .ConvertAndEscape("euc-kr", str);
}

main.getString = function(aName) {
  var strbundle = document.getElementById("stringbundle");
  return strbundle.getString(aName);
}